/* This will create SRELITEP.RXL : a set of  sreLite
macrosapce procedures.
*/


foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 say ' loading REXXLIB '
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
/*--------------   Load REXX libraries ----- */
/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs


names.0=0
say " Create sreLite macrospace procedure library. "
say " This requires that macrospace be cleared (which might effect"
say " other OS/2 programs)"
call charout,'  Enter 1 if you wish to proceed: '
parse pull gogo
if gogo<>1 then do
   say "Nothing done."
   exit
end
foo=macroclear()
if foo=0 then say "Warning: Problem clearing macrospace. "

/* LOAD THE "STATIC" PROCEDURES */
say "Loading static procedures "
retc=amacro('OPENREAD.SRF','SREF_OPEN_READ','Before')
retc=amacro('REPSTRG.SRF','SREF_REPLACESTRG','Before')
retc=amacro('SREFVALU.SRF','SREF_VALUE','Before')

retc=amacro('UNCHUNK.SRF','SREF_UNCHUNK','Before')
retc=amacro('CHUNK.SRF','SREF_CHUNK','Before')


retc=amacro('NOFOUND.SRF','SREF_NOT_FOUND_LOCAL','Before')
retc=amacro('SREFERR.SRF','SREF_ERROR','Before')

retc=amacro('GETBODY.SRF','SREF_GET_BODY','Before')

retc=amacro('WILDCARD.SRF','SREF_WILDCARD','Before')

retc=amacro('PACK64.SRF','SREF_PACK64','Before')
retc=amacro('MKPACK64.SRF','SREF_MKPACK64','Before')

retc=amacro('SREFVER.SRF','SREF_VERSION','Before')
retc=amacro('GRABFIL1.SRF','SREF_GRAB_FILE','Before')
retc=amacro('HOST.SRF','SREF_HOST','Before')
retc=amacro('EXTRACTB.SRF','SREF_EXTRACT_BLOCK','Before')
retc=amacro('ASKAUTH.SRF','SREF_ASK_AUTH','before')
retc=amacro('MKDIGEST.SRF','SREF_DIGEST_AUTH','before')
retc=amacro('DOLOGON.SRF','SREF_DOLOGON','before')
retc=amacro('COMPWORD.SRF','SREF_COMPWORD','Before')

retc=amacro('FIX_URL.SRF','SREF_FIX_URL','Before')
retc=amacro('GET_URL.SRF','SREF_GET_URL','Before')
retc=amacro('SREF_GMT.SRF','SREF_GMT','Before')

retc=amacro('md5.srf','sref_md5','Before')
retc=amacro('rexx_md5.srf','sref_rexx_md5','Before')
retc=amacro('fixurl.SRF','SREF_FIX_URL_EXT','Before')

retc=amacro('GTCOOKIE.SRF','SREF_GET_COOKIE','Before')
retc=amacro('RESPONSE.SRF','SREF_RESPONSE','Before')
retc=amacro('ISAMOVE.SRF','SREF_ISA_MOVE','Before')
retc=amacro('PMPRINTF.SRF','PMPRINTF_SREF','Before')
retc=amacro('ADDCOMMA.SRF','SREF_ADDCOMMA','Before')
retc=amacro('CHKBROWS.SRF','SREF_BROWSER_INFO','Before')
retc=amacro('MULTSEND.SRF','SREF_MULTI_SEND','Before')

retc=amacro('WILDMTCH.SRF','SREF_WILD_MATCH','Before')

retc=amacro('DOCGI.srf','SREF_DOCGI','Before')
retc=amacro('MAILIT.srf','SREF_MAILIT','Before')
retc=amacro('UPWD.SRF','SREF_EXTRACT_UPWD','Before')
retc=amacro('RANGE.SRF','SREF_PROCESS_RANGE','Before')

/* these three are NOT the same as the Sre-http versions
(they are smaller) */
retc=amacro('SREFGOSL.SRF','SREF_GOS','Before')
retc=amacro('DOVIRTL.SRF','SREF_DO_VIRTUAL','Before') 
retc=amacro('SRELNOTF.SRF','SREF_NOT_FOUND_RESPONSE','Before')

retc=amacro('SRELSSI.SRF','SRELI_DO_SSI','Before')
retc=amacro('SRELADON.SRF','SRELI_PROCESS_ADDON','Before')
retc=amacro('SRELDIR.SRF','SRELI_DIR','Before')
retc=amacro('SRELNTF2.SRF','SRELI_NOTFOUND','Before')
retc=amacro('SRELCGI.SRF','SRELI_CGI','Before')
retc=amacro('SRELRANG.SRF','SRELI_RANGE','Before')

say " saving macrospace procedures to SRELITEP.RXL"
foo=macrosave('SRELITEP.RXL')
if foo<>1 then 
        say "Error creating SRELITEP.RXL : " foo
else
        say " success! "
exit


amacro:
parse arg v1,v2,v3
v3=left(v3,1)
foo=macroadd(v2,v1,v3)
if foo=0 then do
   say " Error creating: " v2 " from File=" v1 " ( enter to continue "
   pull .
end /* do */
else
   say " Added " v1 " as " v2 
return foo




